CREATE TABLE contacts ( 
    user_id     int4, 
    contact_id  int4
); 
CREATE INDEX contacts_idx1 ON contacts(user_id); 

CREATE OR REPLACE FUNCTION create_contacts() RETURNS TRIGGER AS $$
     
    if( $_TD->{old}{status} == 1 and 
        $_TD->{new}{status} == 2 ) { 

        my $id1 = $_TD->{new}{user_send}; 
        my $id2 = $_TD->{new}{user_rec}; 

        my $sql1 = "INSERT INTO contacts (user_id, contact_id) VALUES ( $id1, $id2 )"; 
        my $sql2 = "INSERT INTO contacts (user_id, contact_id) VALUES ( $id2, $id1 )"; 

        spi_exec_query($sql1);
        spi_exec_query($sql2);

    }

    return; 

$$ LANGUAGE plperl; 

CREATE TRIGGER contact_creation_trigger BEFORE UPDATE ON visible 
    FOR EACH ROW EXECUTE PROCEDURE create_contacts(); 

